Program Digitalvoltmeter;
Uses CRT;
Var Wert: String;
    RS_AD: Integer;

procedure Sende (Zeichen :Byte);
begin
  while (Port[RS_Ad+5] And 32) = 0 do;  { Senderegister leer ? }
  Port[RS_Ad]:=Zeichen;
end;

function Empfang :Byte;
 Var  i :Integer;
 begin
  i:=0;
  while ((Port[RS_Ad+5] And 1)=0) And (i<1000) do begin
    Inc(i);
    delay(1);
  end;
  if i < 1000 then Empfang:=Port[RS_Ad]
  else Empfang:=0;
end;

procedure Init;
var  i :Word;
begin
  RS_Ad:=$02F8; { Adresse d. ser. Schnittstelle: $03F8 = COM1, $02F8 = COM2 }
  Port[RS_Ad+3]:=$80; { Anwahl d. Teilerfaktors: LSB/MSB }
  Port[RS_Ad+0]:=$60; { $03        $0C       $30       $C0      $80     }
  Port[RS_Ad+1]:=$00; { $00=38400, $00=9600, $00=2400, $00=600, $01=300 }
  Port[RS_Ad+3]:=$06; { 7-Bit, n-Parity, 2 Stopbits }
  Port[RS_Ad+4]:=$01; { DTR = 1, RTS = 0 }
  Port[RS_Ad+1]:=$00; { Keine Interrupts }
  i:=Port[RS_Ad];     { Eingabepuffer leer }
end;

Procedure Abrufen;
var b: Byte;
    Ch: Char;
begin
  sende (ord ('D'));
  Wert := '';
  repeat
    b:= Empfang;
    Ch := chr(b);
    Wert:= Wert + Ch;
  until (b=13) or KeyPressed;
end;

begin
Init;
repeat
  Abrufen;
  writeln (Wert);
  delay (1000);
until KeyPressed;
end.
