program PLL;
uses Crt, RS232;

var Frequenz    : Real;
    Teiler, N   : Integer;

procedure PLL_Init;
  begin
    BusOut (51,54);            { alle drei Timer Betriebsart 3 }
    BusOut (51,118);
    BusOut (51,182);
    BusOut (48,32);            { Teiler 1, 40000   (100 Hz)}
    BusOut (48,156);
    BusOut (49,200);           { Teiler 2, 200 }
    BusOut (49,0);
    BusOut (50,100);           { Teiler 3, 100 }
    BusOut (50,0);
  end;

procedure Einstellen (Frequenz: Real);
  var High, Low  : Byte;
    Teiler : Integer;
  begin
    Teiler := trunc (10 * Frequenz);
    High :=  Hi (Teiler);
    Low :=  Lo (Teiler);
    BusOut (49, Low);
    BusOut (49, High);
  end;

begin
  PLL_Init;
  repeat
    Write ('Frequenz in kHz? ');
    Read (Frequenz);
    Einstellen (Frequenz);
  until Frequenz = 0;
end.

{ Alternative Hauptprogramme: }
begin
  PLL_Init;
    Einstellen (10);
    delay (2000);
    for N := 10 to 1000 do begin
      Frequenz := N;
      Einstellen (Frequenz);
    end;
end.

begin
  PLL_Init;
  Einstellen (80);
  N := 0;
  repeat
    Frequenz := 80 + 70 * sin (n/300);
    Einstellen (Frequenz);
    N := N+1;
  until KeyPressed;
end.
